]> git.madduck.net Git - code/myrepos.git/blobdiff - mr

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

Fix git_fake_bare_update
[code/myrepos.git] / mr
diff --git a/mr b/mr
index a8d864fd5bc2b04440146df2456418892e422ed0..2187aa06b59472cc9c13dfe5367bdd9b4ef59b45 100755 (executable)
--- a/mr
+++ b/mr
@@ -209,7 +209,11 @@ directory, since the repository isn't checked out yet. All other commands
 are run inside the repository, though not necessarily at the top of it.
 
 The "MR_REPO" environment variable is set to the path to the top of the
-repository. The "MR_CONFIG" environment variable is set to the .mrconfig file
+repository. (For the "register" action, "MR_REPO" is instead set to the 
+basename of the directory that should be created when checking the
+repository out.)
+
+The "MR_CONFIG" environment variable is set to the .mrconfig file
 that defines the repo being acted on, or, if the repo is not yet in a config
 file, the .mrconfig file that should be modified to register the repo.
 
@@ -247,6 +251,15 @@ If the "chain" parameter is set and its command returns true, then B<mr>
 will try to load a .mrconfig file from the root of the repository. (You
 should avoid chaining from repositories with untrusted committers.)
 
+=item include
+
+If the "include" parameter is set, its command is ran, and should output
+additional mrconfig file content. The content is included as if it were
+part of the including file.
+
+Unlike all other parameters, this parameter does not need to be placed
+within a section.
+
 =item lib
 
 The "lib" parameter can specify some shell code that will be run before each
@@ -255,6 +268,18 @@ to use.
 
 =back
 
+When looking for a command to run for a given action, mr first looks for
+a parameter with the same name as the action. If that is not found, it
+looks for a parameter named "rcs_action" (substituting in the name of the
+revision control system and the action). The name of the revision control
+system is itself determined by running each defined "rcs_test" action,
+until one succeeds.
+
+Internally, mr has settings for "git_update", "svn_update", etc. To change
+the action that is performed for a given revision control system, you can
+override these rcs specific actions. To add a new revision control system,
+you can just add rcs specific actions for it.
+
 =head1 AUTHOR
 
 Copyright 2007 Joey Hess <joey@kitenet.net>
@@ -289,31 +314,22 @@ my $config_overridden=0;
 my $verbose=0;
 my $stats=0;
 my $no_recurse=0;
+my $no_chdir=0;
 my $jobs=1;
 my %config;
 my %configfiles;
 my %knownactions;
 my %alias;
 my $directory=getcwd();
+my (@ok, @failed, @skipped);
 
-Getopt::Long::Configure("no_permute");
-my $result=GetOptions(
-       "d|directory=s" => sub { $directory=abs_path($_[1]) },
-       "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
-       "v|verbose" => \$verbose,
-       "s|stats" => \$stats,
-       "n|no-recurse" => \$no_recurse,
-       "j|jobs=i" => \$jobs,
-);
-if (! $result || @ARGV < 1) {
-       die("Usage: mr [-d directory] action [params ...]\n".
-           "(Use mr help for man page.)\n");
+getopts();
 
-}
+# This can happen if it's run in a directory that was removed
+# or other strangeness.
 if (! defined $directory) {
        die("mr: failed to determine working directory\n");
 }
-
 # Make sure MR_CONFIG is an absolute path, but don't use abs_path since
 # the config file might be a symlink to elsewhere, and the directory it's
 # in is significant.
@@ -331,175 +347,89 @@ loadconfig($ENV{MR_CONFIG});
 #use Data::Dumper;
 #print Dumper(\%config);
 
-# alias expansion and command stemming
-my $action=shift @ARGV;
-if (exists $alias{$action}) {
-       $action=$alias{$action};
+my $action=expandaction(shift @ARGV);
+dispatch($action);
+showstats($action);
+
+if (@failed) {
+       exit 1;
+}
+elsif (! @ok && @skipped) {
+       exit 1;
 }
-if (! exists $knownactions{$action}) {
-       my @matches = grep { /^\Q$action\E/ }
-               keys %knownactions, keys %alias;
-       if (@matches == 1) {
-               $action=$matches[0];
+else {
+       exit 0;
+}
+
+sub dispatch { #{{{
+       my $action=shift;
+
+       # actions that do not operate on all repos
+       if ($action eq 'help') {
+               help(@ARGV);
        }
-       elsif (@matches == 0) {
-               die "mr: unknown action \"$action\" (known actions: ".
-                       join(", ", sort keys %knownactions).")\n";
+       elsif ($action eq 'config') {
+               config(@ARGV);
        }
-       else {
-               die "mr: ambiguous action \"$action\" (matches: ".
-                       join(", ", @matches).")\n";
+       elsif ($action eq 'register') {
+               register(@ARGV);
        }
-}
 
-# commands that do not operate on all repos
-if ($action eq 'help') {
-       exec($config{''}{DEFAULT}{$action}) || die "exec: $!";
-}
-elsif ($action eq 'config') {
-       if (@ARGV < 2) {
-               die "mr config: not enough parameters\n";
+       if ($jobs > 1) {
+               mrs($action, selectrepos());
        }
-       my $section=shift;
-       if ($section=~/^\//) {
-               # try to convert to a path relative to the config file
-               my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
-               $dir=abs_path($dir);
-               $dir.="/" unless $dir=~/\/$/;
-               if ($section=~/^\Q$dir\E(.*)/) {
-                       $section=$1;
+       else {
+               foreach my $repo (selectrepos()) {
+                       record($repo, action($action, @$repo));
                }
        }
-       my %changefields;
-       foreach (@ARGV) {
-               if (/^([^=]+)=(.*)$/) {
-                       $changefields{$1}=$2;
-               }
-               else {
-                       my $found=0;
-                       foreach my $topdir (sort keys %config) {
-                               if (exists $config{$topdir}{$section} &&
-                                   exists $config{$topdir}{$section}{$_}) {
-                                       print $config{$topdir}{$section}{$_}."\n";
-                                       $found=1;
-                                       last if $section eq 'DEFAULT';
-                               }
-                       }
-                       if (! $found) {
-                               die "mr $action: $section $_ not set\n";
-                       }
-               }
+} #}}}
+
+sub rcs_test { #{{{
+       my ($action, $dir, $topdir, $subdir) = @_;
+
+       my $test="set -e\n";
+       foreach my $rcs_test (
+                       sort {
+                               length $a <=> length $b 
+                                         ||
+                                      $a cmp $b
+                       } grep { /_test$/ } keys %{$config{$topdir}{$subdir}}) {
+               my ($rcs)=$rcs_test=~/(.*)_test/;
+               $test="my_$rcs_test() {\n$config{$topdir}{$subdir}{$rcs_test}\n}\n".$test;
+               $test.="if my_$rcs_test; then echo $rcs; fi\n";
        }
-       modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
-       exit 0;
-}
-elsif ($action eq 'register') {
-       if (! $config_overridden) {
-               # Find the closest known mrconfig file to the current
-               # directory.
-               $directory.="/" unless $directory=~/\/$/;
-               foreach my $topdir (reverse sort keys %config) {
-                       next unless length $topdir;
-                       if ($directory=~/^\Q$topdir\E/) {
-                               $ENV{MR_CONFIG}=$configfiles{$topdir};
-                               last;
-                       }
-               }
+       $test=$config{$topdir}{$subdir}{lib}."\n".$test
+               if exists $config{$topdir}{$subdir}{lib};
+       
+       print "mr $action: running rcs test >>$test<<\n" if $verbose;
+       my $rcs=`$test`;
+       chomp $rcs;
+       if (! length $rcs) {
+               return undef;
        }
-       my $command="set -e; ".$config{''}{DEFAULT}{lib}."\n".
-               "my_action(){ $config{''}{DEFAULT}{$action}\n }; my_action ".
-               join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
-       print STDERR "mr $action: running >>$command<<\n" if $verbose;
-       exec($command) || die "exec: $!";
-}
-
-# an ordered list of repos
-my @list;
-foreach my $topdir (sort keys %config) {
-       foreach my $subdir (sort keys %{$config{$topdir}}) {
-               push @list, {
-                       topdir => $topdir,
-                       subdir => $subdir,
-                       order => $config{$topdir}{$subdir}{order},
-               };
+       else {
+               return $rcs;
        }
-}
-@list = sort {
-               $a->{order}  <=> $b->{order}
-                            ||
-               $a->{topdir} cmp $b->{topdir}
-                            ||
-               $a->{subdir} cmp $b->{subdir}
-       } @list;
-
-# work out what repos to act on
-my @repos;
-my $nochdir=0;
-foreach my $repo (@list) {
-       my $topdir=$repo->{topdir};
-       my $subdir=$repo->{subdir};
-
-       next if $subdir eq 'DEFAULT';
-       my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
-       my $d=$directory;
-       $dir.="/" unless $dir=~/\/$/;
-       $d.="/" unless $d=~/\/$/;
-       next if $no_recurse && $d ne $dir;
-       next if $dir ne $d && $dir !~ /^\Q$d\E/;
-       push @repos, [$dir, $topdir, $subdir];
-}
-if (! @repos) {
-       # fallback to find a leaf repo
-       foreach my $repo (reverse @list) {
-               my $topdir=$repo->{topdir};
-               my $subdir=$repo->{subdir};
-               
-               next if $subdir eq 'DEFAULT';
-               my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
-               my $d=$directory;
-               $dir.="/" unless $dir=~/\/$/;
-               $d.="/" unless $d=~/\/$/;
-               if ($d=~/^\Q$dir\E/) {
-                       push @repos, [$dir, $topdir, $subdir];
-                       last;
-               }
+} #}}}
+       
+sub findcommand { #{{{
+       my ($action, $dir, $topdir, $subdir) = @_;
+       
+       if (exists $config{$topdir}{$subdir}{$action}) {
+               return $config{$topdir}{$subdir}{$action};
        }
-       $nochdir=1;
-}
 
-# run the action on each repository and print stats
-my (@ok, @failed, @skipped);
-if ($jobs > 1) {
-       mrs(@repos);
-}
-else {
-       foreach my $repo (@repos) {
-               record($repo, action($action, @$repo));
-       }
-}
-if (! @ok && ! @failed && ! @skipped) {
-       die "mr $action: no repositories found to work on\n";
-}
-print "mr $action: finished (".join("; ",
-       showstat($#ok+1, "ok", "ok"),
-       showstat($#failed+1, "failed", "failed"),
-       showstat($#skipped+1, "skipped", "skipped"),
-).")\n";
-if ($stats) {
-       if (@skipped) {
-               print "mr $action: (skipped: ".join(" ", @skipped).")\n";
+       my $rcs=rcs_test(@_);
+
+       if (defined $rcs && 
+           exists $config{$topdir}{$subdir}{$rcs."_".$action}) {
+               return $config{$topdir}{$subdir}{$rcs."_".$action};
        }
-       if (@failed) {
-               print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
+       else {
+               return undef;
        }
-}
-if (@failed) {
-       exit 1;
-}
-elsif (! @ok && @skipped) {
-       exit 1;
-}
-exit 0;
+} #}}}
 
 sub action { #{{{
        my ($action, $dir, $topdir, $subdir) = @_;
@@ -526,12 +456,15 @@ sub action { #{{{
                        return action("checkout", $dir, $topdir, $subdir);
                }
        }
-       
+
        $ENV{MR_REPO}=$dir;
 
-       if (exists $config{$topdir}{$subdir}{skip}) {
+       my $skiptest=findcommand("skip", $dir, $topdir, $subdir);
+       my $command=findcommand($action, $dir, $topdir, $subdir);
+
+       if (defined $skiptest) {
                my $test="set -e;".$lib.
-                       "my_action(){ $config{$topdir}{$subdir}{skip}\n }; my_action '$action'";
+                       "my_action(){ $skiptest\n }; my_action '$action'";
                print "mr $action: running skip test >>$test<<\n" if $verbose;
                my $ret=system($test);
                if ($ret != 0) {
@@ -550,16 +483,23 @@ sub action { #{{{
                }
        }
        
-       if (! $nochdir && ! chdir($dir)) {
+       if (! $no_chdir && ! chdir($dir)) {
                print STDERR "mr $action: failed to chdir to $dir: $!\n";
                return FAILED;
        }
-       elsif (! exists $config{$topdir}{$subdir}{$action}) {
-               print STDERR "mr $action: no defined $action command for $topdir$subdir, skipping\n";
-               return SKIPPED;
+       elsif (! defined $command) {
+               my $rcs=rcs_test(@_);
+               if (! defined $rcs) {
+                       print STDERR "mr $action: unknown repository type and no defined $action command for $topdir$subdir\n";
+                       return FAILED;
+               }
+               else {
+                       print STDERR "mr $action: no defined $action command for $rcs repository $topdir$subdir, skipping\n";
+                       return SKIPPED;
+               }
        }
        else {
-               if (! $nochdir) {
+               if (! $no_chdir) {
                        print "mr $action: $topdir$subdir\n";
                }
                else {
@@ -567,10 +507,10 @@ sub action { #{{{
                        $s=~s/^\Q$topdir$subdir\E\/?//;
                        print "mr $action: $topdir$subdir (in subdir $s)\n";
                }
-               my $command="set -e; ".$lib.
-                       "my_action(){ $config{$topdir}{$subdir}{$action}\n }; my_action ".
+               $command="set -e; ".$lib.
+                       "my_action(){ $command\n }; my_action ".
                        join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
-               print STDERR "mr $action: running >>$command<<\n" if $verbose;
+               print "mr $action: running >>$command<<\n" if $verbose;
                my $ret=system($command);
                if ($ret != 0) {
                        if (($? & 127) == 2) {
@@ -603,6 +543,9 @@ sub action { #{{{
 
 # run actions on multiple repos, in parallel
 sub mrs { #{{{
+       my $action=shift;
+       my @repos=@_;
+
        $| = 1;
        my @active;
        my @fhs;
@@ -691,6 +634,25 @@ sub record { #{{{
        }
 } #}}}
 
+sub showstats { #{{{
+       if (! @ok && ! @failed && ! @skipped) {
+               die "mr $action: no repositories found to work on\n";
+       }
+       print "mr $action: finished (".join("; ",
+               showstat($#ok+1, "ok", "ok"),
+               showstat($#failed+1, "failed", "failed"),
+               showstat($#skipped+1, "skipped", "skipped"),
+       ).")\n";
+       if ($stats) {
+               if (@skipped) {
+                       print "mr $action: (skipped: ".join(" ", @skipped).")\n";
+               }
+               if (@failed) {
+                       print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
+               }
+       }
+} #}}}
+
 sub showstat { #{{{
        my $count=shift;
        my $singular=shift;
@@ -701,6 +663,64 @@ sub showstat { #{{{
        return;
 } #}}}
 
+# an ordered list of repos
+sub repolist { #{{{
+       my @list;
+       foreach my $topdir (sort keys %config) {
+               foreach my $subdir (sort keys %{$config{$topdir}}) {
+                       push @list, {
+                               topdir => $topdir,
+                               subdir => $subdir,
+                               order => $config{$topdir}{$subdir}{order},
+                       };
+               }
+       }
+       return sort {
+               $a->{order}  <=> $b->{order}
+                            ||
+               $a->{topdir} cmp $b->{topdir}
+                            ||
+               $a->{subdir} cmp $b->{subdir}
+       } @list;
+} #}}}
+
+# figure out which repos to act on
+sub selectrepos { #{{{
+       my @repos;
+       foreach my $repo (repolist()) {
+               my $topdir=$repo->{topdir};
+               my $subdir=$repo->{subdir};
+
+               next if $subdir eq 'DEFAULT';
+               my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
+               my $d=$directory;
+               $dir.="/" unless $dir=~/\/$/;
+               $d.="/" unless $d=~/\/$/;
+               next if $no_recurse && $d ne $dir;
+               next if $dir ne $d && $dir !~ /^\Q$d\E/;
+               push @repos, [$dir, $topdir, $subdir];
+       }
+       if (! @repos) {
+               # fallback to find a leaf repo
+               foreach my $repo (reverse repolist()) {
+                       my $topdir=$repo->{topdir};
+                       my $subdir=$repo->{subdir};
+                       
+                       next if $subdir eq 'DEFAULT';
+                       my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
+                       my $d=$directory;
+                       $dir.="/" unless $dir=~/\/$/;
+                       $d.="/" unless $d=~/\/$/;
+                       if ($d=~/^\Q$dir\E/) {
+                               push @repos, [$dir, $topdir, $subdir];
+                               last;
+                       }
+               }
+               $no_chdir=1;
+       }
+       return @repos;
+} #}}}
+
 my %loaded;
 sub loadconfig { #{{{
        my $f=shift;
@@ -775,6 +795,12 @@ sub loadconfig { #{{{
                                chomp $value;
                        }
 
+                       if ($parameter eq "include") {
+                               print "mr: including output of \"$value\"\n" if $verbose;
+                               unshift @lines, `$value`;
+                               next;
+                       }
+
                        if (! defined $section) {
                                die "$f line $.: parameter ($parameter) not in section\n";
                        }
@@ -792,7 +818,12 @@ sub loadconfig { #{{{
                        }
                        else {
                                $config{$dir}{$section}{$parameter}=$value;
-                               $knownactions{$parameter}=1;
+                               if ($parameter =~ /.*_(.*)/) {
+                                       $knownactions{$1}=1;
+                               }
+                               else {
+                                       $knownactions{$parameter}=1;
+                               }
                                if ($parameter eq 'chain' &&
                                    length $dir && $section ne "DEFAULT" &&
                                    -e $dir.$section."/.mrconfig") {
@@ -918,6 +949,123 @@ sub modifyconfig { #{{{
        print $out @out;
        close $out;     
 } #}}}
+       
+sub help { #{{{
+       exec($config{''}{DEFAULT}{$action}) || die "exec: $!";
+} #}}}
+       
+sub config { #{{{
+       if (@_ < 2) {
+               die "mr config: not enough parameters\n";
+       }
+       my $section=shift;
+       if ($section=~/^\//) {
+               # try to convert to a path relative to the config file
+               my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
+               $dir=abs_path($dir);
+               $dir.="/" unless $dir=~/\/$/;
+               if ($section=~/^\Q$dir\E(.*)/) {
+                       $section=$1;
+               }
+       }
+       my %changefields;
+       foreach (@_) {
+               if (/^([^=]+)=(.*)$/) {
+                       $changefields{$1}=$2;
+               }
+               else {
+                       my $found=0;
+                       foreach my $topdir (sort keys %config) {
+                               if (exists $config{$topdir}{$section} &&
+                                   exists $config{$topdir}{$section}{$_}) {
+                                       print $config{$topdir}{$section}{$_}."\n";
+                                       $found=1;
+                                       last if $section eq 'DEFAULT';
+                               }
+                       }
+                       if (! $found) {
+                               die "mr $action: $section $_ not set\n";
+                       }
+               }
+       }
+       modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
+       exit 0;
+} #}}}
+
+sub register { #{{{
+       if (! $config_overridden) {
+               # Find the closest known mrconfig file to the current
+               # directory.
+               $directory.="/" unless $directory=~/\/$/;
+               foreach my $topdir (reverse sort keys %config) {
+                       next unless length $topdir;
+                       if ($directory=~/^\Q$topdir\E/) {
+                               $ENV{MR_CONFIG}=$configfiles{$topdir};
+                               $directory=$topdir;
+                               last;
+                       }
+               }
+       }
+       if (@ARGV) {
+               my $subdir=shift @ARGV;
+               if (! chdir($subdir)) {
+                       print STDERR "mr $action: failed to chdir to $subdir: $!\n";
+               }
+       }
+
+       $ENV{MR_REPO}=getcwd();
+       my $command=findcommand("register", $ENV{MR_REPO}, $directory, 'DEFAULT');
+       if (! defined $command) {
+               die "mr $action: unknown repository type\n";
+       }
+
+       $ENV{MR_REPO}=~s/.*\/(.*)/$1/;
+       $command="set -e; ".$config{$directory}{DEFAULT}{lib}."\n".
+               "my_action(){ $command\n }; my_action ".
+               join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
+       print "mr $action: running >>$command<<\n" if $verbose;
+       exec($command) || die "exec: $!";
+} #}}}
+
+# alias expansion and command stemming
+sub expandaction { #{{{
+       my $action=shift;
+       if (exists $alias{$action}) {
+               $action=$alias{$action};
+       }
+       if (! exists $knownactions{$action}) {
+               my @matches = grep { /^\Q$action\E/ }
+                       keys %knownactions, keys %alias;
+               if (@matches == 1) {
+                       $action=$matches[0];
+               }
+               elsif (@matches == 0) {
+                       die "mr: unknown action \"$action\" (known actions: ".
+                               join(", ", sort keys %knownactions).")\n";
+               }
+               else {
+                       die "mr: ambiguous action \"$action\" (matches: ".
+                               join(", ", @matches).")\n";
+               }
+       }
+       return $action;
+} #}}}
+
+sub getopts { #{{{
+       Getopt::Long::Configure("no_permute");
+       my $result=GetOptions(
+               "d|directory=s" => sub { $directory=abs_path($_[1]) },
+               "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
+               "v|verbose" => \$verbose,
+               "s|stats" => \$stats,
+               "n|no-recurse" => \$no_recurse,
+               "j|jobs=i" => \$jobs,
+       );
+       if (! $result || @ARGV < 1) {
+               die("Usage: mr [-d directory] action [params ...]\n".
+                   "(Use mr help for man page.)\n");
+       }
+} #}}}
 
 # Finally, some useful actions that mr knows about by default.
 # These can be overridden in ~/.mrconfig.
@@ -931,7 +1079,6 @@ ls = list
 [DEFAULT]
 order = 10
 lib =
-       PWD="$pwd"
        error() {
                echo "mr: $@" >&2
                exit 1
@@ -963,196 +1110,98 @@ lib =
                        exit 1
                fi
        }
-       get_git_repo_type()
-       {
-               if [ -d "$1"/.git ] && [ -d "$1"/.git/refs/heads ] &&
-                       [ -d "$1"/.git/objects ] && [ -f "$1"/.git/config ];
-                       then
-                       echo non-bare
-               elif [ -d "$1"/refs/heads ] && [ -d "$1"/refs/tags ] &&
-                       [ -d "$1"/objects ] && [ -f "$1"/config ]; then
-                       local bare
-                       bare="$(GIT_CONFIG="$1"/config git-config --get core.bare)"
-                       case "$bare" in
-                               true) echo bare;;
-                               false) echo fake-bare;;
-                               *) return 255;;
-                       esac
-               else
-                       return 1
-               fi
-       }
-       is_git_repo() {
-               get_git_repo_type "$1" >/dev/null
-       }
-       get_repo_type() {
-               if [ -d "$1"/.svn ]; then
-                       echo svn
-               elif is_git_repo "$1"; then
-                       echo git
-               elif [ -d "$1"/.bzr ]; then
-                       echo bzr
-               elif [ -d "$1"/CVS ]; then
-                       echo CVS
-               elif [ -d "$1"/.hg ]; then
-                       echo hg
-               elif [ -d "$1"/_darcs ]; then
-                       echo darcs
-               else
-                       echo unknown
-               fi
-       }
 
-update =
-       case "$(get_repo_type "$MR_REPO")" in
-       svn) svn update "$@";;
-       git)
-               # all this is because of a bug in git-fetch, which requires GIT_DIR set
-               local git_dir_override; git_dir_override=.git
-               case "$(get_git_repo_type "$MR_REPO")" in
-                       fake-bare) git_dir_override="$MR_REPO";;
-               esac
-               args="$@"
-               [ -z "$args" ] && args="-t origin master"
-               eval GIT_DIR="$git_dir_override" git pull "$args"
-               ;;
-       bzr) bzr merge "$@";;
-       CVS) cvs update "$@";;
-       hg) hg pull "$@" && hg update "$@";;
-       darcs) darcs pull -a "$@";;
-       *) error "unknown repo type";;
-       esac
-
-status =
-       case "$(get_repo_type "$MR_REPO")" in
-       svn) svn status "$@";;
-       git) git status "$@" || :;;
-       bzr) bzr status "$@";;
-       CVS) cvs status "$@";;
-       hg) hg status "$@";;
-       darcs) darcs whatsnew -ls "$@";;
-       *) error "unknown repo type";;
-       esac
-
-commit =
-       case "$(get_repo_type "$MR_REPO")" in
-       svn) svn commit "$@";;
-       git)
-               case "$(get_git_repo_type "$MR_REPO")" in
-                       bare) error "cannot commit to bare git repositories";;
-                       fake-bare) error "commit does not work for fake bare git repositories (yet).";;
-               esac
-               git commit -a "$@" && git push --all
-               ;;
-       bzr) bzr commit "$@" && bzr push;;
-       CVS) cvs commit "$@";;
-       hg) hg commit -m "$@" && hg push;;
-       darcs) darcs commit -a -m "$@" && darcs push -a;;
-       *) error "unknown repo type";;
-       esac
-
-diff =
-       case "$(get_repo_type "$MR_REPO")" in
-       svn) svn diff "$@";;
-       git)
-               case "$(get_git_repo_type "$MR_REPO")" in
-                       bare) error "cannot diff in bare git repositories";;
-                       fake-bare) error "diff does not work for fake bare git repositories (yet).";;
-               esac
-               git diff "$@"
-               ;;
-       bzr) bzr diff "$@";;
-       CVS) cvs diff "$@";;
-       hg) hg diff "$@";;
-       darcs) darcs diff "$@";;
-       *) error "unknown repo type";;
-       esac
-
-log =
-       case "$(get_repo_type "$MR_REPO")" in
-       svn) svn log"$@";;
-       git) git log "$@";;
-       bzr) bzr log "$@";;
-       CVS) cvs log "$@";;
-       hg) hg log "$@";;
-       darcs) darcs changes "$@";;
-       *) error "unknown repo type";;
-       esac
-
-register =
-       if [ -n "$1" ]; then
-               cd "$1"
+svn_test = test -d "$MR_REPO"/.svn
+git_test = test -d "$MR_REPO"/.git
+bzr_test = test -d "$MR_REPO"/.bzr
+cvs_test = test -d "$MR_REPO"/CVS
+hg_test  = test -d "$MR_REPO"/.hg
+darcs_test = test -d "$MR_REPO"/_darcs
+git_bare_test =
+       test -d "$MR_REPO"/refs/heads && test -d "$MR_REPO"/refs/tags &&
+       test -d "$MR_REPO"/objects && test -f "$MR_REPO"/config &&
+       test "$(GIT_CONFIG="$MR_REPO"/config git-config --get core.bare)" = true
+
+svn_update = svn update "$@"
+git_update = if [ "$@" ]; then git pull "$@"; else git pull -t origin master; fi
+bzr_update = bzr merge "$@"
+cvs_update = cvs update "$@"
+hg_update  = hg pull "$@" && hg update "$@"
+darcs_update = darcs pull -a "$@"
+
+svn_status = svn status "$@"
+git_status = git status "$@" || true
+bzr_status = bzr status "$@"
+cvs_status = cvs status "$@"
+hg_status  = hg status "$@"
+darcs_status = darcs whatsnew -ls "$@"
+
+svn_commit = svn commit "$@"
+git_commit = git commit -a "$@" && git push --all
+bzr_commit = bzr commit "$@" && bzr push
+cvs_commit = cvs commit "$@"
+hg_commit  = hg commit -m "$@" && hg push
+darcs_commit = darcs commit -a -m "$@" && darcs push -a
+
+svn_diff = svn diff "$@"
+git_diff = git diff "$@"
+bzr_diff = bzr diff "$@"
+cvs_diff = cvs diff "$@"
+hg_diff  = hg diff "$@"
+darcs_diff = darcs diff "$@"
+
+svn_log = svn log "$@"
+git_log = git log "$@"
+bzr_log = bzr log "$@"
+cvs_log = cvs log "$@"
+hg_log  = hg log "$@"
+darcs_log = darcs changes "$@"
+git_bare_log = git log "$@"
+
+svn_register =
+       url=$(LANG=C svn info . | grep -i ^URL: | cut -d ' ' -f 2)
+       if [ -z "$url" ]; then
+               error "cannot determine svn url"
        fi
-       basedir="$(basename $PWD)"
-       case "$(get_repo_type .)" in
-       svn)
-               url=$(LANG=C svn info . | grep -i ^URL: | cut -d ' ' -f 2)
-               if [ -z "$url" ]; then
-                       error "cannot determine svn url"
-               fi
-               echo "Registering svn url: $url in $MR_CONFIG"
-               mr -c "$MR_CONFIG" config "$PWD" checkout="svn co $url $basedir"
-               ;;
-       git)
-               local repo_type; repo_type="$(get_git_repo_type .)"
-               local config;
-               case "$repo_type" in
-                       non-bare) config=.git/config;;
-                       bare|fake-bare) config=config;;
-               esac
-               url="$(LANG=C GIT_CONFIG="$config" git-config --get remote.origin.url)"
-               if [ -z "$url" ]; then
-                       error "cannot determine git url"
-               fi
-               case "$repo_type" in
-                       bare|fake-bare)
-                               # this seems like a bare repo as it has no
-                               # worktree.
-                               local work_tree
-                               work_tree="$(git-config --get core.worktree)" || :
-                               if [ ! -d "$work_tree" ]; then
-                                       error "git worktree $work_tree does not exist"
-                               fi
-                               suffix=" (with worktree $work_tree)"
-                               mr -c "$MR_CONFIG" config "$PWD" \
-                                       lib="GIT_WORK_TREE=$work_tree; export GIT_WORK_TREE"
-                               ;;
-               esac
-               echo "Registering git url: $url in $MR_CONFIG${suffix:-}"
-               mr -c "$MR_CONFIG" config "$PWD" checkout="git clone $url $basedir"
-               ;;
-       bzr)
-               url=$(cat .bzr/branch/parent)
-               if [ -z "$url" ]; then
-                       error "cannot determine bzr url"
-               fi
-               echo "Registering bzr url: $url in $MR_CONFIG"
-               mr -c "$MR_CONFIG" config "$PWD" checkout="bzr clone $url $basedir"
-               ;;
-       CVS)
-               repo=$(cat CVS/Repository)
-               root=$(cat CVS/Root)
-               if [ -z "$root" ]; then
-                       error "cannot determine cvs root"
+       echo "Registering svn url: $url in $MR_CONFIG"
+       mr -c "$MR_CONFIG" config "`pwd`" checkout="svn co '$url' '$MR_REPO'"
+git_register = 
+       url="$(LANG=C git-config --get remote.origin.url)" || true
+       if [ -z "$url" ]; then
+               error "cannot determine git url"
+       fi
+       echo "Registering git url: $url in $MR_CONFIG"
+       mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone '$url' '$MR_REPO'"
+bzr_register =
+       url=$(cat .bzr/branch/parent)
+       if [ -z "$url" ]; then
+               error "cannot determine bzr url"
+       fi
+       echo "Registering bzr url: $url in $MR_CONFIG"
+       mr -c "$MR_CONFIG" config "`pwd`" checkout="bzr clone '$url' '$MR_REPO'"
+cvs_register =
+       repo=$(cat CVS/Repository)
+       root=$(cat CVS/Root)
+       if [ -z "$root" ]; then
+               error "cannot determine cvs root"
                fi
-               echo "Registering cvs repository $repo at root $root"
-               mr -c "$MR_CONFIG" config "$PWD" \
-                       checkout="cvs -d '$root' co -d $basedir $repo"
-               ;;
-       hg)
-               url=$(hg showconfig paths.default)
-               echo "Registering mercurial repo url: $url in $MR_CONFIG"
-               mr -c "$MR_CONFIG" config "$PWD" \
-                       checkout="hg clone $url $basedir"
-               ;;
-       darcs)
-               url=$(cat _darcs/prefs/defaultrepo)
-               echo "Registering darcs repository $url in $MR_CONFIG"
-               mr -c "$MR_CONFIG" config "$PWD" \
-                       checkout="darcs get $url $basedir"
-               ;;
-       *) error "unable to register this repo type";;
-       esac
+       echo "Registering cvs repository $repo at root $root"
+       mr -c "$MR_CONFIG" config "`pwd`" checkout="cvs -d '$root' co -d '$MR_REPO' '$repo'"
+hg_register = 
+       url=$(hg showconfig paths.default)
+       echo "Registering mercurial repo url: $url in $MR_CONFIG"
+       mr -c "$MR_CONFIG" config "`pwd`" checkout="hg clone '$url' '$MR_REPO'"
+darcs_register = 
+       url=$(cat _darcs/prefs/defaultrepo)
+       echo "Registering darcs repository $url in $MR_CONFIG"
+       mr -c "$MR_CONFIG" config "`pwd`" checkout="darcs get '$url'p '$MR_REPO'"
+git_bare_register = 
+       url="$(LANG=C GIT_CONFIG=config git-config --get remote.origin.url)" || true
+       if [ -z "$url" ]; then
+               error "cannot determine git url"
+       fi
+       echo "Registering git url: $url in $MR_CONFIG"
+       mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone --bare '$url' '$MR_REPO'"
 
 help =
        if [ ! -e "$MR_PATH" ]; then